"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.esbuildResolve = void 0;
const path = __importStar(require("path"));
const esbuild_1 = __importDefault(require("esbuild"));
const esbuildResolve = ({ esbuild: esBuildOptions = {}, } = {}) => {
    let esbuildPluginBuild = null;
    let esbuildResult = null;
    return {
        name: 'esbuild-resolve',
        async buildStart() {
            if (!esbuildResult) {
                [esbuildResult, esbuildPluginBuild] = await new Promise((resolve) => {
                    let pluginBuildTmp;
                    esbuild_1.default
                        .build(Object.assign(Object.assign({}, esBuildOptions), { watch: true, plugins: [
                            {
                                name: 'resolve-grab',
                                setup(pluginBuild) {
                                    pluginBuild.onStart(() => {
                                        pluginBuildTmp = pluginBuild;
                                    });
                                },
                            },
                            ...(esBuildOptions.plugins || []),
                        ] }))
                        .then((result) => {
                        resolve([result, pluginBuildTmp]);
                    });
                });
            }
        },
        async buildEnd() {
            if (esbuildResult && esbuildResult.stop) {
                esbuildResult.stop();
                esbuildResult = null;
                esbuildPluginBuild = null;
            }
        },
        async resolveId(source, importer, options) {
            if (esbuildPluginBuild) {
                const { isEntry } = options;
                const resolveDir = isEntry || !importer ? path.dirname(source) : path.dirname(importer);
                const { path: id, sideEffects: moduleSideEffects, external, errors, warnings, } = await esbuildPluginBuild.resolve(source, { resolveDir, kind: 'entry-point' });
                if (errors && errors.length > 0) {
                    /*
                    errors.forEach(({ text }) => {
                      this.error(text);
                    });
                    */
                }
                if (warnings && warnings.length > 0) {
                    warnings.forEach(({ text }) => {
                        this.warn(text);
                    });
                }
                const esbuildResolvedResult = id ? { id, external, moduleSideEffects } : null;
                if (esbuildResolvedResult) {
                    const rollupResolvedResult = await this.resolve(id, importer, Object.assign(Object.assign({}, options), { skipSelf: true }));
                    if (rollupResolvedResult) {
                        // Handle plugins that manually make the result external and the external option
                        if (rollupResolvedResult.external) {
                            return false;
                        }
                        // Allow other plugins to take over resolution
                        if (rollupResolvedResult.id !== id) {
                            return rollupResolvedResult;
                        }
                        return Object.assign(Object.assign({}, esbuildResolvedResult), { meta: rollupResolvedResult.meta });
                    }
                }
                return esbuildResolvedResult;
            }
            return null;
        },
    };
};
exports.esbuildResolve = esbuildResolve;
//# sourceMappingURL=index.js.map